using System;
using System.Collections.Generic;
using ModelInterfaces;

namespace ModelImplementation
{
	/* implementation af Var */

	public class Vare : IVare
	{
		// vare-objektes memory (datafelter)
		private int      varenr;
		private string   betegnelse;
		private int      antalPLager;
		private float    salgsEnhedsPris;            // aktuel excl. moms

		private List<IVarebevaegelse> varebevaegelser = new List<IVarebevaegelse>();

		// constructor til brug for skabelse af eksisterende vare
		public Vare (int varenr, string betegnelse, int antalPLager, float salgsEnhedsPris)
		{
			this.varenr = varenr;
			this.betegnelse = betegnelse;
			this.antalPLager = antalPLager;
			this.salgsEnhedsPris = salgsEnhedsPris;
		}

		#region Vare Members
		public int Varenr
		{
			get { return this.varenr; }
		}
		public string Betegnelse
		{
			get { return this.betegnelse; }
			set 
			{ 
				this.betegnelse = value;
			}
		}
		public int AntalPLager
		{
			get { return this.antalPLager; }
		}

		public float SalgsEnhedsPris
		{
			get { return this.salgsEnhedsPris; }
			set { this.salgsEnhedsPris = value; }
		}
		public double Salgsvrdi()
		{
			double salgsvrdi = this.antalPLager * this.salgsEnhedsPris;
			return salgsvrdi;
		}
		#endregion
    public IVarebevaegelse RegistrerVarerSolgt (int antal,
                                               int dato, 
                                               float stykpris)
    {
			this.antalPLager = this.antalPLager - antal;
			IVarebevaegelse nyVarebevaegelse = new Varebevaegelse(antal,dato,stykpris,1);
			this.varebevaegelser.Add(nyVarebevaegelse);
			return nyVarebevaegelse;
    }
    public IVarebevaegelse RegistrerVarerIndkbt (int antal,
                                                 int dato, 
                                                 float stykpris)
    {
			this.antalPLager = this.antalPLager + antal;
			IVarebevaegelse nyVarebevaegelse = new Varebevaegelse(antal,dato,stykpris,0);
			this.varebevaegelser.Add(nyVarebevaegelse);
			return nyVarebevaegelse;
		}

    public List<IVarebevaegelse> GetBevgelser ()
    {
      return new List<IVarebevaegelse>(this.varebevaegelser);
    }

		public override string ToString ()
		{
			return ""+this.varenr+", "+this.betegnelse+", "+this.salgsEnhedsPris+", "+this.antalPLager;
		}

	}
}
